const accounting = require('accounting');

let str = ["oi", "oi", "ola", "bom dia", "boa tarde", "boa noite", "como vai", "ei", "oii", "oiii", "oiiii", "oiiiii", "oiiiiii", "oiiiiiii", "ooi", "oooi", "oooii", "ooooii", "ooooiii", "oola", "olaa", "olaaa", "hola", "holaa", "heloo", "hello", "helooo", "hellooo", "booa", "boaa",
    "tudo bem", "tudo bem", "como vai", "tudo certo", "obrigado", "certo", "entendi", "entendi mas", "certo mas", "olá!", "ola!"];


let Util = {};


Util.isPhrase = function (phrase) {
    return phrase.split(" ").length >= 3
};

function wordInString(s, words, replacement) {

    s = removeDotsAndComma(s);

    let re = new RegExp('(\\s|^)(?:' + words.join('|') + ')(?=\\s|$)');
    return s.replace(re, replacement);
}

function removeDotsAndComma(phrase) {
    let regex = /[.,]/g;
    return phrase.replace(regex, '');
}

Util.replaceIfIsPhrase = function (phrase) {
    return Util.isPhrase(phrase) ? wordInString(phrase, str, "").trim() : phrase;
};


Util.capitalizeFirstLetter = function (string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
};


Util.dateDiffInDays = function (a, b) {
    let _MS_PER_DAY = 1000 * 60 * 60 * 24;
    // Discard the time and time-zone information.
    let utc1 = Date.UTC(a.getFullYear(), a.getMonth(), a.getDate());
    let utc2 = Date.UTC(b.getFullYear(), b.getMonth(), b.getDate());

    return Math.floor((utc2 - utc1) / _MS_PER_DAY);
};


Util.toReal = function (numero) {
    let num = numero;

    if (typeof numero === 'string') {
        num = Number.parseFloat(numero);
    }

    return accounting.formatMoney(num, 'R$ ', 2, '.', ',');
};

module.exports = Util;
